﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Menus;
using Infragistics.DragDrop;

namespace xamDataTree_DragAndDrop
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Group> Groups { get; set; }
        public MainWindow()
        {
            Groups = new ObservableCollection<Group>();
            Groups.Add(new Group { DisplayName = "Group 1" });
            Groups.Add(new Group { DisplayName = "Group 2" });
            Groups.Add(new Group { DisplayName = "Group 3" });

            Groups[0].Products = new ObservableCollection<Product>()
            {
                new Product { DisplayName = "Product 1" },
                new Product { DisplayName = "Product 2" },
                new Product { DisplayName = "Product 3" },
            };
            Groups[1].Products = new ObservableCollection<Product>()
            {
                new Product { DisplayName = "Product 4" },
                new Product { DisplayName = "Product 5" },
                new Product { DisplayName = "Product 6" },
            };
            Groups[2].Products = new ObservableCollection<Product>()
            {
                new Product { DisplayName = "Product 7" },
                new Product { DisplayName = "Product 8" },
                new Product { DisplayName = "Product 9" },
            };

            Groups[0].Products[0].Licenses = new ObservableCollection<License>()
            {
                new License { DisplayName = "License 1" },
                new License { DisplayName = "License 2" },
                new License { DisplayName = "License 3" },
            };
            Groups[0].Products[1].Licenses = new ObservableCollection<License>()
            {
                new License { DisplayName = "License 4" },
                new License { DisplayName = "License 5" },
                new License { DisplayName = "License 6" },
            };
            Groups[0].Products[2].Licenses = new ObservableCollection<License>()
            {
                new License { DisplayName = "License 7" },
                new License { DisplayName = "License 8" },
                new License { DisplayName = "License 9" },
            };

            InitializeComponent();
            this.DataContext = this;
        }

        private void NodeLoaded(object sender, RoutedEventArgs e)
        {
            //XamDataTreeNodeControl control = (XamDataTreeNodeControl)sender;

            //if (control.Node.Data.GetType() == typeof(Group))
            //    DragDropManager.SetDropTarget(control, new DropTarget() { IsDropTarget = true });
            //if (control.Node.Data.GetType() == typeof(License))
            //{
            //    DragSource source = new DragSource();
            //    source.IsDraggable = true;
            //    source.Drop += new EventHandler<DropEventArgs>(source_Drop);

            //    //DragSource src = 

            //    //DragDropManager.SetDragSource(control, source);
            //}
        }

        void source_Drop(object sender, DropEventArgs e)
        {
            License license = (e.DragSource as XamDataTreeNodeControl).Node.Data as License;
            Group group = (e.DropTarget as XamDataTreeNodeControl).Node.Data as Group;

            // Perform the logic for adding the license to the target group.
        }

        private void XamDataTree_NodeDraggingStart(object sender, DragDropStartEventArgs e)
        {
            //XamDataTreeNodeControl control = (XamDataTreeNodeControl)e.DragSource;

            //DragSource src = DragDropManager.GetDragSource(control);
            //src.DragOver += new EventHandler<DragDropMoveEventArgs>(src_DragOver);
            //src.DragChannels.Add("ChannelA");
            //e.Cancel = true;
            //DragSource source = new DragSource();
            //source.IsDraggable = true;
            //source.Drop += new EventHandler<DropEventArgs>(source_Drop);
            //DragDropManager.SetDragSource(e.DragSource, source);
        }

        

        private void XamDataTree_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.LeftCtrl)
            {
                xamDataTree1.IsDraggable = false;
                xamDataTree1.IsDropTarget = false;
            }
        }

        private void XamDataTree_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.LeftCtrl)
            {
                xamDataTree1.IsDraggable = true;
                xamDataTree1.IsDropTarget = true;
            }
        }

        private void xamDataTree1_NodeDraggingStart(object sender, DragDropStartEventArgs e)
        {
            // Only need to perform this workaround if we're dragging license nodes.
            if ((e.DragSource as XamDataTreeNodeControl).Node.Data.GetType() == typeof(License))
            {
                DragSource src = DragDropManager.GetDragSource(e.DragSource);
                src.DragEnter += src_DragEnter;
                src.DragLeave += src_DragLeave;
                src.Drop += src_Drop;
            }
        }

        void src_DragEnter(object sender, DragDropCancelEventArgs e)
        {
            // Reset the cursor template if the node we're over is a Group node
            if ((e.DropTarget as XamDataTreeNodeControl).Node.Data.GetType() == typeof(Group))
            {
                e.DropNotAllowedCursorTemplate = DragDropManager.CurrentMoveCursorTemplate;
                Rectangle rect = (Rectangle)Infragistics.Windows.Utilities.GetDescendantFromName(e.DropTarget as XamDataTreeNodeControl, "DropOntoElem");
                rect.Opacity = 1.0;
            }
        }

        void src_DragLeave(object sender, DragDropEventArgs e)
        {
            // Reset the cursor template if the node we're over is a Group node
            if ((e.DropTarget as XamDataTreeNodeControl).Node.Data.GetType() == typeof(Group))
            {
                e.DropNotAllowedCursorTemplate = null;
                Rectangle rect = (Rectangle)Infragistics.Windows.Utilities.GetDescendantFromName(e.DropTarget as XamDataTreeNodeControl, "DropOntoElem");
                rect.Opacity = 0.0;
            }
        }

        void src_Drop(object sender, DropEventArgs e)
        {
            // Disconnect the events for memory reasons.
            DragSource src = DragDropManager.GetDragSource(e.DragSource);
            src.DragEnter -= src_DragEnter;
            src.DragLeave -= src_DragLeave;
            src.Drop -= src_Drop;

            if ((e.DropTarget as XamDataTreeNodeControl).Node.Data.GetType() == typeof(Group))
            {
                MessageBox.Show("Dropped onto Group node");
            }
        }
    }

    public class Group
    {
        public ObservableCollection<Product> Products { get; set; }

        public string DisplayName { get; set; }
    }
    public class Product
    {
        public ObservableCollection<License> Licenses { get; set; }

        public string DisplayName { get; set; }
    }
    public class License
    {
        public string DisplayName { get; set; }
    }
}
